package com.cirmuller.maidaddition.threads;

package .tmp;

import com.cirmuller.maidaddition.threads.CalculateCraftingStackThread;
import java.util.Iterator;
import java.util.List;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraftforge.common.capabilities.ForgeCapabilities;
import net.minecraftforge.common.util.LazyOptional;
import net.minecraftforge.items.IItemHandler;

public class ChestPos {
  public int index;
  
  public BlockPos pos;
  
  @Nullable
  public static ChestPos findItemInChests(ServerLevel level, List<BlockPos> chests, Item item) {
    ChestPos result = new ChestPos();
    result.index = -1;
    result.pos = null;
    for (Iterator<BlockPos> iterator = chests.iterator(); iterator.hasNext(); ) {
      BlockPos chest = iterator.next();
      BlockEntity chestEntity = level.m_7702_(chest);
      if (chestEntity != null) {
        LazyOptional<IItemHandler> capability = chestEntity.getCapability(ForgeCapabilities.ITEM_HANDLER);
        capability.ifPresent(cap -> {
              int sz = cap.getSlots();
              for (int i = 0; i < sz; i++) {
                ItemStack stack = cap.getStackInSlot(i);
                if (stack.m_41720_().equals(item)) {
                  result.index = i;
                  result.pos = chest;
                  break;
                } 
              } 
            });
        if (result.index != -1)
          break; 
      } 
    } 
    if (result.index == -1)
      return null; 
    return result;
  }
}
